#include <cassert>
#include <cstdlib>
#include "Computer.hpp"

int NimComputer::fetch_move(const Nim& game) const {
   assert(!game.finished());
   int size = game.size_of_heap();
   if (size <= 3) {
      return size;
   }
   int modulo = size % 4;
   if (modulo < 1) {
      // oh well... lets try a random move
      return std::rand() % 3 + 1;
   } else {
      // this looks fine :)
      return modulo;
   }
}
