#include <iostream>
#include "Game.hpp"

using namespace std;

NimGame::NimGame(NimPlayer* p1, NimPlayer* p2) {
   players[0] = p1; players[1] = p2;
}

NimGame::NimGame(NimPlayer* p1, NimPlayer* p2, const Nim& nim) :
      game(nim) {
   players[0] = p1; players[1] = p2;
}

void NimGame::run() {
   while (!game.finished()) {
      cout << "Noch sind es " << game.size_of_heap() << " Staebchen." << endl;
      NimPlayer& p(*(players[game.next_player()]));
      int move = p.fetch_move(game);
      game.perform_move(move);
      cout << p.get_name() << " nimmt " << move << " Staebchen." << endl;
   }
   cout << get_winner() << " hat gewonnen." << endl;
}

const std::string& NimGame::get_winner() const {
   return players[game.winner()]->get_name();
}
