#ifndef NIMM_H
#define NIMM_H

typedef enum {PLAYER1, PLAYER2} player;
class Nim {
   public:
      // constructors
      Nim();
      Nim(int initial_size);
      Nim(const Nim& other);

      // accessors
      bool finished() const;
      int size_of_heap() const;
      player winner() const;
         // PRE: finished() is true
      player next_player() const;
         // PRE: finished() is false
      bool valid(int move) const;
         // PRE: finished() is false

      // mutators
      void perform_move(int move);
         // PRE: finished() is false and valid(move) is true

   private:
      player other_player() const;
      int heap_size;
      player whose_turn;
};

#endif
