#include "Nim.hpp"
#include "Computer.hpp"
#include "Human.hpp"
#include "Game.hpp"
#include <iostream>
#include <cstdlib>

using namespace std;

int main() {
   srand(time(0)); // seed random generator

   // creat a game object
   Nim nim;

   // explain the rules
   cout << "*** Nimm-Spiel ***" << endl;
   cout << "Ein Haufen mit " << nim.size_of_heap() <<
      " Staebchen liegt vor." << endl;
   cout << "In jedem Zug koennen zwischen 1 und 3 Staebchen entfernt werden."
      << endl;
   cout << "Wer die letzten Staebchen entfernt, hat gewonnen." << endl;

   // ask for the name
   std::string name;
   cout << "Ihr Name: ";
   NimPlayer* human;
   if (cin >> name) {
      human = new NimHuman(name);
   } else {
      cout << "Das war wohl nichts!" << endl; return 0;
   }

   // free choice of the beginning player
   NimPlayer* computer = new NimComputer();
   NimPlayer* p1; NimPlayer* p2;
   int choice;
   cout << "Wer soll anfangen? 1=Sie 2=Computer" << endl;
   if (cin >> choice && (choice == 1 || choice == 2)) {
      switch (choice) {
         case 1: p1 = human; p2 = computer; break;
         case 2: p1 = computer; p2 = human; break;
      }
   } else {
      cout << "Das war wohl nichts!" << endl; return 0;
   }

   // run the game
   NimGame game(p1, p2, nim);
   game.run();
}
